# DO NOT EDIT - This file is being maintained by Chef
-# Initialize timestamp with day of latest planet dump
-# Setting to midnight ensures we get conistent data after first run
-# osmosis --read-replication-interval-init
+# Before running updates, the replication needs to be set up with the timestamp
+# set to the day of the latest planet dump. Setting to midnight ensures we get
+# conistent data after first run. osmosis --read-replication-interval-init is
+# used to initially create the state file
+
+# Define exit handler
+function onexit {
+ [ -f state-prev.txt ] && mv state-prev.txt state.txt
+}
# Send output to the log
exec > /var/log/tile/replicate.log 2>&1
# Change to the replication state directory
cd /var/lib/replicate
+# Install exit handler
+trap onexit EXIT
+
# Read in initial state
. state.txt
# Work out the name of the next file
file="changes-${sequenceNumber}.osm.gz"
+ # Save state file so we can rollback if an error occurs
+ cp state.txt state-prev.txt
+
# Fetch the next set of changes
osmosis --read-replication-interval --simc --write-xml-change file="${file}" compressionMethod="gzip"
if [ $? -eq 0 ]
then
# Enable exit on error
- set -e
+ set -e
# Remember the previous sequence number
- prevSequenceNumber=$sequenceNumber
+ prevSequenceNumber=$sequenceNumber
# Read in new state
- . state.txt
+ . state.txt
# Did we get any new data?
- if [ "${sequenceNumber}" == "${prevSequenceNumber}" ]
+ if [ "${sequenceNumber}" == "${prevSequenceNumber}" ]
then
# Log the lack of data
- echo "No new data available. Sleeping..."
+ echo "No new data available. Sleeping..."
- # Remove file, it will just be an empty changeset
- rm ${file}
+ # Remove file, it will just be an empty changeset
+ rm ${file}
+
+ # No need to rollback now
+ rm state-prev.txt
# Sleep for a short while
- sleep 30
- else
+ sleep 30
+ else
# Log the new data
- echo "Fetched new data from ${prevSequenceNumber} to ${sequenceNumber} into ${file}"
+ echo "Fetched new data from ${prevSequenceNumber} to ${sequenceNumber} into ${file}"
# Apply the changes to the database
<% if node[:tile][:node_file] -%>
- osm2pgsql --slim --append --flat-nodes=<%= node[:tile][:node_file] %> ${file}
+ osm2pgsql --slim --append --number-processes=1 --flat-nodes=<%= node[:tile][:node_file] %> ${file}
<% else -%>
- osm2pgsql --slim --append ${file}
+ osm2pgsql --slim --append --number-processes=1 ${file}
<% end -%>
+ # No need to rollback now
+ rm state-prev.txt
+
# Expire tiles which are touched by the changes
sudo -u www-data /usr/local/bin/expire-tiles ${file} > /dev/null 2>&1 &
- fi
+ fi
# Delete old downloads
- find . -name 'changes-*.gz' -mmin +300 -exec rm -f {} \;
+ find . -name 'changes-*.gz' -mmin +300 -exec rm -f {} \;
# Disable exit on error
set +e
else
# Log our failure to fetch changes
- echo "Failed to fetch changes - waiting a few minutes before retry"
+ echo "Failed to fetch changes - waiting a few minutes before retry"
# Wait five minutes and have another go
- sleep 300
+ sleep 300
fi
done